var ToodledoVars = window.arguments[0];
var ToodledoFolders = window.arguments[1];
var ToodledoFolderIds = window.arguments[2];
var ToodledoContexts = window.arguments[3];
var ToodledoContextIds = window.arguments[4];
var ToodledoGoals = window.arguments[5];
var ToodledoGoalIds = window.arguments[6];
var loadedFolders = 0;
var loadedContexts = 0;
var loadedGoals = 0;

function Toodledo_UrlLoaded() {
	var res=httpRequest.responseText;
	var xml=httpRequest.responseXML;
	
	//Toodledo_Log(res);	

	if(xml.firstChild) {
		var root_node = xml.firstChild.tagName;
		
		if(root_node=="userid") {
		
			var userid = xml.firstChild.textContent;
			if(userid==0) {
				Toodledo_AddError();
			} else if(userid==1) {
				Toodledo_AddError();
			} else {
				branch.setCharPref("toodledopref_userid", userid);
				ToodledoGetAPIKey(); //once we get a userid, try to get a key
			}
			
		} else if(root_node=="token") {
		
			var email = branch.getCharPref("toodledopref_email");
			var token = xml.firstChild.textContent;
			var password = Toodledo_GetPassword(email);
			var userid = branch.getCharPref("toodledopref_userid");
			
			ToodledoVars.key = ToodledoMD5(ToodledoMD5(password)+token+userid);

			Toodledo_AddLoad();	
			
		} else if(root_node=="folders") {
		
			var folders = xml.firstChild;
			
			if(folders.childNodes.length==0) {
				ToodledoFolders[0] = "None";
				ToodledoFolderIds[i] = "0";
			} else { 
				var j=0;
				for(var i=0;i<folders.childNodes.length;i++) {
					if(folders.childNodes[i].attributes[2].value==0) { //hide archived folders
						ToodledoFolders[j] = folders.childNodes[i].textContent;
						ToodledoFolderIds[j] = folders.childNodes[i].attributes[0].value;
						j++;
					}
				}
			}
			Toodledo_AddLoad();	
			
		} else if(root_node=="contexts") {
			
			var contexts = xml.firstChild;
			
			if(contexts.childNodes.length==0) {
				ToodledoContexts[0] = "None";
				ToodledoContextIds[i] = "0";
			} else { 
				for(var i=0;i<contexts.childNodes.length;i++) {
					ToodledoContexts[i] = contexts.childNodes[i].textContent;
					ToodledoContextIds[i] = contexts.childNodes[i].attributes[0].value;
					if(contexts.childNodes[i].attributes[1].value==1) ToodledoContextIds[999] = contexts.childNodes[i].attributes[0].value;//default
				}
			}
			Toodledo_AddLoad();	
			
		} else if(root_node=="goals") {

			var goals = xml.firstChild;
			
			if(goals.childNodes.length==0) {
				ToodledoGoals[0] = "None";
				ToodledoGoalIds[i] = "0";
			} else { 
				for(var i=0;i<goals.childNodes.length;i++) {
					ToodledoGoals[i] = goals.childNodes[i].textContent;
					ToodledoGoalIds[i] = goals.childNodes[i].attributes[0].value;
				}
			}
			Toodledo_AddLoad();	
			
		} else if(root_node=="error") { //TODO: if an error comes back, we can't add a task, so alter the dialog to display an error.
			
			var error_value = xml.firstChild.textContent;
			//Toodledo_Log(error_value);	
			
			if(error_value=="key did not validate") { //perhaps the key expired. Try one more time
				if(TryOnce) {
					Toodledo_AddError();
					TryOnce=0;
				} else {
					ToodledoGetAPIKey(); 
					timeoutID = setTimeout("Toodledo_AddLoad()",1000); //try again in 1 second
					TryOnce++;
				}
			} else if(error_value=="invalid userid") {
				Toodledo_AddError();
			} else if(error_value=="no userid specified") {
				Toodledo_AddError();
			} 
			
		} else {
			Toodledo_Log("Unknown response from toodledo.com");	
		}
	
	}
}

function Toodledo_AddError() {
	document.getElementById("add.task.caption").label = "Error";
	document.getElementById("add.task.form").hidden = true;
	document.getElementById("add.task.error").hidden = false;
	branch.setCharPref("toodledopref_userid", ""); //userid is not valid anymore
	Toodledo_setPassword("");
	if(timeoutID!=0) clearTimeout(timeoutID);			
}

function Toodledo_AddLoad() {
	ToodledoVars.url = null;

	if(timeoutID!=0) clearTimeout(timeoutID); //if there is a timeout, clear it
	
	if(ToodledoVars.selectedText) document.getElementById("toodledo.add.title").value =  ToodledoVars.selectedText;
	
	document.getElementById("Toodledoadd1").hidden = !branch.getBoolPref("toodledopref_check1"); 
	document.getElementById("Toodledoadd2").hidden = !branch.getBoolPref("toodledopref_check2");
	document.getElementById("Toodledoadd3").hidden = !branch.getBoolPref("toodledopref_check3");
	document.getElementById("Toodledoadd4").hidden = !branch.getBoolPref("toodledopref_check4");
	document.getElementById("Toodledoadd6").hidden = !branch.getBoolPref("toodledopref_check6");
	document.getElementById("Toodledoadd7").hidden = !branch.getBoolPref("toodledopref_check7");
	document.getElementById("Toodledoadd8").hidden = !branch.getBoolPref("toodledopref_check8");
	document.getElementById("Toodledoadd9").hidden = !branch.getBoolPref("toodledopref_check9");
	document.getElementById("Toodledoadd10").hidden = !branch.getBoolPref("toodledopref_check10"); //due time
	
	if(!ToodledoVars.key) { //need key to continue
		ToodledoGetAPIKey();
		timeoutID = setTimeout("Toodledo_AddLoad()",4000); //try again in 4 second
	} 

	if(branch.getBoolPref("toodledopref_check1")) {  //refresh folder list
		if(ToodledoFolders.length>0) { //if the folders are loaded
			var menu = document.getElementById("toodledo.add.folders");
			
			if(loadedFolders==0) { //if the menu isnt yet constructed
				for(var i=0;i<ToodledoFolders.length;i++) { //construct the menu
					menu.appendItem(ToodledoFolders[i],ToodledoFolderIds[i]);
				}
				loadedFolders = 1;
			}
		} else { //try to load the folders array
			if(ToodledoVars.key) {
				Toodledo_GetUrl(";method=getFolders",true,ToodledoVars.key);
			}
			if(timeoutID==0) timeoutID = setTimeout("Toodledo_AddLoad()",5000); //try again in 5 seconds
		
		}
	}
	
	if(branch.getBoolPref("toodledopref_check8")) {  //refresh context list
		
		if(ToodledoContexts.length>0) { //if the context are loaded and the menu isnt			
			var menu = document.getElementById("toodledo.add.contexts");
			
			if(loadedContexts==0) { //if the menu isnt yet constructed
				var added=null;
				for(var i=0;i<ToodledoContexts.length;i++) { //construct the menu
					added = menu.appendItem(ToodledoContexts[i],ToodledoContextIds[i]);
					if(ToodledoContextIds[i]==ToodledoContextIds[999]) menu.selectedItem = added;//set default
				}
				loadedContexts = 1;
			}
		} else { //try to load the context array
			if(ToodledoVars.key) {
				Toodledo_GetUrl(";method=getContexts",true,ToodledoVars.key);
			}
			if(timeoutID==0) timeoutID = setTimeout("Toodledo_AddLoad()",5200); //try again in 5.2 second
		
		}
	}
	
	if(branch.getBoolPref("toodledopref_check9")) {  //refresh goal list
		
		if(ToodledoGoals.length>0) { //if the goals are loaded and the menu isnt			
			var menu = document.getElementById("toodledo.add.goal");
			
			if(loadedGoals==0) { //if the menu isnt yet constructed
				var added=null;
				for(var i=0;i<ToodledoGoals.length;i++) { //construct the menu
					added = menu.appendItem(ToodledoGoals[i],ToodledoGoalIds[i]);
				}
				loadedGoals = 1;
			}
		} else { //try to load the context array
			if(ToodledoVars.key) {
				Toodledo_GetUrl(";method=getGoals",true,ToodledoVars.key);
			}
			if(timeoutID==0) timeoutID = setTimeout("Toodledo_AddLoad()",5200); //try again in 5.2 second
		
		}
	}
}

function Toodledo_AddTask() {

	var title = document.getElementById("toodledo.add.title").value;
	var folder = document.getElementById("toodledo.add.folders").value;
	var duedate = document.getElementById("toodledo.add.duedate").value;
	var repeat = document.getElementById("toodledo.add.repeat").value;
	var length = ToodledoTimeToMins(document.getElementById("toodledo.add.length").value);
	var priority = document.getElementById("toodledo.add.priority").value;
	var tag = document.getElementById("toodledo.add.tag").value;
	var context = document.getElementById("toodledo.add.contexts").value;
	var goal = document.getElementById("toodledo.add.goal").value;
	var duetime = document.getElementById("toodledo.add.duetime").value;
	
	if(!branch.getBoolPref("toodledopref_check1")) folder="";
	if(!branch.getBoolPref("toodledopref_check2")) duedate="";
	if(!branch.getBoolPref("toodledopref_check3")) repeat="";
	if(!branch.getBoolPref("toodledopref_check4")) length="";
	if(!branch.getBoolPref("toodledopref_check6")) priority="";
	if(!branch.getBoolPref("toodledopref_check7")) tag="";
	if(!branch.getBoolPref("toodledopref_check8")) context="";
	if(!branch.getBoolPref("toodledopref_check9")) goal="";
	if(!branch.getBoolPref("toodledopref_check10")) duetime="";
	
	title = title.replace("&","%26");
	title = title.replace(";","%3B");
	title = title.replace("+","%2B");
	title = title.replace("%","%25");
	tag = tag.replace("%","%25");
	tag = tag.replace("&","%26");
	tag = tag.replace(";","%3B");
	tag = tag.replace("+","%2B");
	
	var url = ";method=addTask;title="+title+";folder="+folder+";duedate="+duedate+";repeat="+repeat+";length="+length+";priority="+priority+";tag="+tag+";context="+context+";goal="+goal+";duetime="+duetime;
		
	if(title) ToodledoVars.url = url; //TODO: give warning if empty title
}
