const consoleService = Components.classes['@mozilla.org/consoleservice;1'].getService(Components.interfaces.nsIConsoleService);
const prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
const branch = prefService.getBranch("toodledo.");

var toodledo_password_key = "http://www.toodledo.com/status-auth/";
var toodledo_api_url = "http://www.toodledo.com/api.php?f=1;key=";
var httpRequest;
var TryOnce = 0;
var timeoutID = 0;

/*

UNKNOWN BUGS

Why are localizations giving errors?
Why does the sidebar load each time a dialog is dismissed?

*/



function Toodledo_Log(aMessage) {
	consoleService.logStringMessage('Toodledo: ' + aMessage);
}

function Toodledo_GetUrl(url,async,key) {
	//Toodledo_Log(toodledo_api_url+key+url);
	
    httpRequest = new XMLHttpRequest();
    httpRequest.overrideMimeType('text/xml');
      
    if(async) {
		httpRequest.onreadystatechange = function(aEvt) {
			if (httpRequest.readyState == 4) {
				if(httpRequest.status == 200) Toodledo_UrlLoaded();
				else Toodledo_Log("Error loading \n");
			}
		};
	}
	httpRequest.open("GET", toodledo_api_url+key+url, async); //true means async
    httpRequest.send(null);
    if(!async) {
    	if(httpRequest.status == 200) Toodledo_UrlLoaded();
		else Toodledo_Log("Error loading \n");
    }
}



function ToodledoReformatTime(elem) {
	var time = elem.value;
	
	var strbundle = document.getElementById("toodledostrings");
	var str_min=strbundle.getString("min");
	var str_mins=strbundle.getString("mins");
	var str_hour=strbundle.getString("hour");
	var str_hours=strbundle.getString("hours");
	var str_day=strbundle.getString("day");
	var str_days=strbundle.getString("days");
	
	if(time.indexOf(":")==-1) {
		var parts = time.match(/(\d*\.?\d*)(\D*)/i);
		time = Math.round(parts[1]*10)/10;
		if(parts[2].indexOf("d")>=0) mins = time*1440;
		else if(parts[2].indexOf("D")>=0) mins = time*1440;
		else if(parts[2].indexOf("h")>=0) mins = time*60;
		else if(parts[2].indexOf("H")>=0) mins = time*60;
		else mins = time;
	} else {
		var parts = time.match(/(\d*):(\d*)/i);
		mins = parseInt(parts[1])*60+parseInt(parts[2]);
	}
	if(1) { //english output
		if(mins>=1440) {
			time = Math.round(mins/144)/10;
			if(time==1) time+= " "+str_day; else time+= " "+str_days;
		} else if(mins>=60) {
			time = Math.round(mins/6)/10;
			if(time==1) time+= " "+str_hour; else time+= " "+str_hours;
		} else {
			if(mins==1) time= "1 "+str_min; else time = mins+" "+str_mins;
		}
	} else { //HH:MM output
		if(mins>=60) {
			time = Math.floor(mins/60);
			mins = mins%60;
			if(mins<10) mins = "0"+mins;
			time += ":"+mins;
		} else {
			if(mins<10) mins = "0"+mins;
			time = "0:"+mins;
		}
	}
	elem.value = time;
}

function ToodledoTimeToMins(time) {
	if(time.indexOf('h')!=-1) {
		time = time.substr(0,time.indexOf(' '))*60;
	} else if(time.indexOf('d')!=-1) {
		time = time.substr(0,time.indexOf(' '))*60*24;
	} else {
		time = time.substr(0,time.indexOf(' '))*1;
	}

	return time;
}

function toHexString(charCode) {
	 return ("0" + charCode.toString(16)).slice(-2);
}
	
function ToodledoMD5(str) {
	var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
	
	converter.charset = "UTF-8";
	var result = {};
	var data = converter.convertToByteArray(str, result);
	var ch = Components.classes["@mozilla.org/security/hash;1"].createInstance(Components.interfaces.nsICryptoHash);
	ch.init(ch.MD5);
	ch.update(data, data.length);
	var hash = ch.finish(false);
	
	s = [toHexString(hash.charCodeAt(i)) for (i in hash)].join("");
	return s.substr(0,32);
}

function Toodledo_GetPassword(email) {
	var host = {value:""};
	var user =  {value:""};
	var tmp_password = {value:""};
	
	try {
		if("@mozilla.org/passwordmanager;1" in Components.classes) { //FF2.0
			var passwordManager = Components.classes["@mozilla.org/passwordmanager;1"].createInstance().QueryInterface(Components.interfaces.nsIPasswordManagerInternal); //FF2.0
			passwordManager.findPasswordEntry(toodledo_password_key, email, null, host, user, tmp_password);
	   	} else if ("@mozilla.org/login-manager;1" in Components.classes) { //FF3.0
	   		var passwordManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
		 	var logins = passwordManager.findLogins({}, 'chrome://toodledo', 'User Registration', null);
			  
		   // Find user from returned array of nsILoginInfo objects
		   for (var i = 0; i < logins.length; i++) {
			  	if (logins[i].username == email) {
				 	tmp_password.value = logins[i].password;
				 	break;
				}
			}
		}
   
	} catch (e) {  
		//couldnt find password
	} 
	
	return tmp_password.value;
}

function Toodledo_GetUserId() {
	var email = branch.getCharPref("toodledopref_email");
	var pass = Toodledo_GetPassword(email);
	
	email = email.replace("&","%26");
	email = email.replace(";","%3B");
	email = email.replace("+","%2B");
	email = email.replace("%","%25");
	pass = pass.replace("%","%25");
	pass = pass.replace("&","%26");
	pass = pass.replace(";","%3B");
	pass = pass.replace("+","%2B");
	
	if(email && pass) { //only try to get a userid if the user has entered credentials
		Toodledo_GetUrl(";method=getUserid;email="+email+";pass="+pass,true,"");
	} else {
		if(timeoutID!=0) clearTimeout(timeoutID); //we cant continue without username/pass
	}
}

function ToodledoGetAPIKey() {
	var userid = branch.getCharPref("toodledopref_userid");
	if(userid) { //we have a userid, so ask for a token
		Toodledo_GetUrl(";method=getToken;userid="+userid,true,"");
	} else {  //if we dont have a userid, then we need to verify their login credentials and fetch the userid
		Toodledo_GetUserId(); 
	}
}

function Toodledo_gotoweb(url) {
	var branch = prefService.getBranch("browser.");
	var parentWindow = null;
	
	
	if(window.opener) {
        if(window.opener.opener)  parentWindow = window.opener.opener;
      	else parentWindow = window.opener;
    } else {
    	parentWindow = window;
    }
	
	if(branch.getIntPref("link.open_newwindow")==3) { // If the open tabs preference is set to true
       	parentWindow.getBrowser().selectedTab = parentWindow.getBrowser().addTab(url);
    } else {
        parentWindow.open(url);
    }
}

function Toodledo_setPassword(pass) {
	var email = branch.getCharPref("toodledopref_email");
	var oldpass = Toodledo_GetPassword(email);
	
	try {
		if("@mozilla.org/passwordmanager;1" in Components.classes) { //FF2.0
			var passwordSaver = Components.classes["@mozilla.org/passwordmanager;1"].createInstance().QueryInterface(Components.interfaces.nsIPasswordManager);
			passwordSaver.removeUser(toodledo_password_key, email);
		} else if ("@mozilla.org/login-manager;1" in Components.classes) { //FF3.0
			var passwordManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
			
			var nsLoginInfo = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1",Components.interfaces.nsILoginInfo,"init");
			var extLoginInfo = new nsLoginInfo('chrome://toodledo','User Registration', null, email, oldpass, "", "");
			passwordManager.removeLogin(extLoginInfo);
		}
	} catch (e) {		
		//there was nothing to remove
	}

	if(email && pass) {
		try {
			if("@mozilla.org/passwordmanager;1" in Components.classes) { //FF2.0
				passwordSaver.addUser(toodledo_password_key, email, pass);
			} else if ("@mozilla.org/login-manager;1" in Components.classes) { //FF3.0
				var passwordManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
			
				var nsLoginInfo = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1",Components.interfaces.nsILoginInfo,"init");
				var extLoginInfo = new nsLoginInfo('chrome://toodledo','User Registration', null, email, pass, "", "");
				passwordManager.addLogin(extLoginInfo);
			}
		} catch (e) {
			Toodledo_Log("Error storing password");
		}
	}
}