var ToodledoLoaded = false;

var ToodledoVars = { key: null, url: null, selectedText: null } ;
var ToodledoFolders = new Array();
var ToodledoFolderIds = new Array();
var ToodledoContexts = new Array();
var ToodledoContextIds = new Array();
var ToodledoGoals = new Array();
var ToodledoGoalIds = new Array();

function Toodledo_Init() {
	if(ToodledoLoaded == false) {
		Toodledo_Log("1.42.0");
		ToodledoLoaded = true;

		ToodledoUpdateContext();
		
		var menu = document.getElementById("contentAreaContextMenu");
		menu.addEventListener('popupshowing', ToodledoUpdateContext, false);
	}
}

function Toodledo_UrlLoaded() {
	var res=httpRequest.responseText;
	var xml=httpRequest.responseXML;
	
	///Toodledo_Log(res);	

	if(xml.firstChild) {
		var root_node = xml.firstChild.tagName;
		
		if(root_node=="userid") {
		
			var userid = xml.firstChild.textContent;
			if(userid==0) {
				//we only get here if the password was never entered correctly
				Toodledo_setPassword("");
			} else if(userid==1) {
				//we only get here if the password was never entered correctly
				Toodledo_setPassword("");
			} else {
				branch.setCharPref("toodledopref_userid", userid);
				ToodledoGetAPIKey(); //once we get a userid, try to get a key
			}
			
		} else if(root_node=="token") {
			var email = branch.getCharPref("toodledopref_email");
			var token = xml.firstChild.textContent;
			var password = Toodledo_GetPassword(email);
			var userid = branch.getCharPref("toodledopref_userid");
			
			ToodledoVars.key = ToodledoMD5(ToodledoMD5(password)+token+userid);
			
		} else if(root_node=="added") {
		
			var added = xml.firstChild.textContent;
			
			
		} else if(root_node=="folders") {
			var folders = xml.firstChild;
			
			var j=0;
			for(var i=0;i<folders.childNodes.length;i++) {
				if(folders.childNodes[i].attributes[2].value==0) { //hide archived folders
					ToodledoFolders[j] = folders.childNodes[i].textContent;
					ToodledoFolderIds[j] = folders.childNodes[i].attributes[0].value;
					j++;
				}
			}
						
		} else if(root_node=="contexts") {
			//Toodledo_Log("contexts1");
			var contexts = xml.firstChild;
			
			for(var i=0;i<contexts.childNodes.length;i++) {
				ToodledoContexts[i] = contexts.childNodes[i].textContent;
				ToodledoContextIds[i] = contexts.childNodes[i].attributes[0].value;
				if(contexts.childNodes[i].attributes[1].value==1) ToodledoContextIds[999] = contexts.childNodes[i].attributes[0].value;//default
			}
			
		} else if(root_node=="goals") {
			//Toodledo_Log("goals");
			var goals = xml.firstChild;
			
			for(var i=0;i<goals.childNodes.length;i++) {
				ToodledoGoals[i] = goals.childNodes[i].textContent;
				ToodledoGoalIds[i] = goals.childNodes[i].attributes[0].value;
			}
			
		} else if(root_node=="tasks") {

			
		} else if(root_node=="error") {
			var error_value = xml.firstChild.textContent;
			//Toodledo_Log(error_value);	
			
			if(error_value=="key did not validate") {  //perhaps the key expired. Try one more time
				if(TryOnce) {
					var strbundle = document.getElementById("toodledostrings");
					alert(strbundle.getString("error"));
					branch.setCharPref("toodledopref_userid", ""); //userid is not valid anymore
					Toodledo_setPassword("");
					TryOnce=0;
				} else {
					ToodledoGetAPIKey();
					timeoutID = setTimeout("Toodledo_AddTask()",1000); //try again in 1 second
					TryOnce++;
				}
				
			} else if(error_value=="invalid userid") {

			} else if(error_value=="no userid specified") {

			} 
		} else {
			Toodledo_Log("Unknown response from toodledo.com");	
		}
	
	}
}

function Toodledo_AddTask() {	
	if(timeoutID!=0) clearTimeout(timeoutID); //if there is a timeout, clear it
	
	if(!ToodledoVars.key) {
		ToodledoGetAPIKey();
		timeoutID = setTimeout("Toodledo_AddTask()",2000); //try again in 2 seconds
	} else {
		Toodledo_GetUrl(ToodledoVars.url,true,ToodledoVars.key);
	}
}

//========= TOOLS MENU ========================================================================


function Toodledo_add() {
	var userid = branch.getCharPref("toodledopref_userid");
	ToodledoVars.selectedText = "";
	TryOnce=0;
	if(userid) {
		window.openDialog("chrome://toodledo/content/add.xul", "Toodledo-Add", "centerscreen,chrome,modal,resizable",ToodledoVars,ToodledoFolders,ToodledoFolderIds,ToodledoContexts,ToodledoContextIds,ToodledoGoals,ToodledoGoalIds);
		if(ToodledoVars.url) Toodledo_AddTask();
	
	} else {
		var strbundle = document.getElementById("toodledostrings");
		alert(strbundle.getString("error2"));
	}
}

function Toodledo_refresh() {
	//unload folders, contexts and goals
	//Toodledo_Log("Refresh");
	
	ToodledoFolders = new Array();
	ToodledoFolderIds = new Array();
	ToodledoContexts = new Array();
	ToodledoContextIds = new Array();
	ToodledoGoals = new Array();
	ToodledoGoalIds = new Array();
} 

function Toodledo_options() {
	window.openDialog("chrome://toodledo/content/options.xul", "Toodledo-Options", "centerscreen,chrome,modal,resizable",ToodledoVars);
}


//========= CONTEXT MENU ========================================================================

function ToodledoUpdateContext() {
	ToodledoVars.selectedText = Toodledo_getSelection();
	var userid = branch.getCharPref("toodledopref_userid");
	var strbundle = document.getElementById("toodledostrings");
	var isLink = false;
	if(document.getElementById("context-copylink") && document.getElementById("context-copylink").hidden==false) isLink=true;
	
	
	if(userid && ToodledoVars.selectedText) {
		document.getElementById("toodledo.context.add").label = strbundle.getString("toodledo")+" \""+ToodledoVars.selectedText.substr(0,20)+"...\"";
		document.getElementById("toodledo.context.add").hidden = false;
	} else if(userid) {
		document.getElementById("toodledo.context.add").label = strbundle.getString("something");
		document.getElementById("toodledo.context.add").hidden = false;
	} else {
		if(TryOnce) {
			TryOnce=0;
		} else {
			timeoutID = setTimeout("ToodledoUpdateContext()",1000); //try again in 1 second
			Toodledo_GetUserId();
			TryOnce++;
		}
		
		document.getElementById("toodledo.context.add").hidden = true;
		document.getElementById("toodledo.context.sep").hidden = true;
	}
	
	if(gContextMenu && userid && isLink) {
		ToodledoVars.selectedText = gContextMenu.linkText()+" : "+gContextMenu.linkURL;
		
		document.getElementById("toodledo.context.addlink").label = strbundle.getString("link");
		document.getElementById("toodledo.context.addlink").hidden = false;
	} else {
		document.getElementById("toodledo.context.addlink").hidden = true;
	}
}

function Toodledo_addtext(isLink) {
	if(!isLink) ToodledoVars.selectedText = Toodledo_getSelection();
	TryOnce=0;
	window.openDialog("chrome://toodledo/content/add.xul", "Toodledo-Add", "centerscreen,chrome,modal,resizable",ToodledoVars,ToodledoFolders,ToodledoFolderIds,ToodledoContexts,ToodledoContextIds,ToodledoGoals,ToodledoGoalIds);
	if(ToodledoVars.url) Toodledo_AddTask();
}

function Toodledo_getSelection() {
    var focusedWindow = document.commandDispatcher.focusedWindow;
    var selection = focusedWindow.getSelection();
    return String(selection);
}

